/*
Carlos RiosDigital Calligraphy - Carlos RiosDigital Calligraphy - Carlos Rios

press "b" to blur,
press "r" to drawn in red
press "q" to draw in black
press "space" to clear screen...

*/

int num = 500; //numbers of particles defined
Spring[] springs = new Spring[num];

void setup()
{
  
 size(600, 480, P3D);
 //angleMode(DEGREES);
 ellipseMode(CENTER);
 background(255);
 //Creates Text
  PFont font;
  font = loadFont("Dialog-12.vlw"); 
  textFont(font); 
  fill(0, 102, 153);
  text("Digital Calligraphy", 415, 380); 
  fill(152,38,120);
  text("B - Blur", 415, 400); 
  text("Q - Black BG", 415, 415);
  text("Space bar - Reset",415, 430);
  text("Hold R for red slashes", 415, 445);
  text("Hold T for thin slashes", 415, 460);
  text("Hold Y for lighter slashes", 415, 475);
 for ( int b = 0; b<num; b++)
 {
   springs[b] = new Spring(random(width), random(height), random(0.8,
   0.9), random(1,15), random(0.1,0.9));
 }
 //smooth();

}

void draw()
{
if(keyPressed){
  if(key == 'q'){
    background(0); //black background
  }
}
 for ( int a = 0; a<num; a++)
 {
   springs[a].update();
   springs[a].drawdraw();
 }
 //blur();
 if(keyPressed) {
  if(key == 'b')
 {
    blur();
 
 }
 }
}

/*
If you press any key, the program goes back to the initial state
*/

void keyPressed()
{
 if(key == ' ')
 {
   setup();
 }

}

/*
Following is a class that defines the movement of the each of dots
*/

class Spring
{
 // Screen values
 float xpos, ypos;
 float tempxpos, tempypos;
 //int size = 20;
 boolean over = false;
 boolean move = false;

 // Spring simulation constants
 float mass;       // Mass
 float k = 0.2;    // Spring constant
 float damp;       // Damping
 float rest_posx;  // Rest position X
 float rest_posy;  // Rest position Y

 // Spring simulation variables
 float velx = 0.0;   // X Velocity
 float vely = 0.0;   // Y Velocity
 float accel = 0;    // Acceleration
 float force = 0;    // Force

 //This is for keeping track of the previous and current movement of the particles.
 int hist=2;
 float historyX[];
 float historyY[];

 // Constructor
 Spring(float x, float y, float d, float m,
 float k_in)
 {
   xpos = tempxpos = x;
   ypos = tempypos = y;
   rest_posx = x;
   rest_posy = y;

   damp = d;
   mass = m;
   k = k_in;

   historyX=new float[hist];
   historyY=new float[hist];
 }

 /*
 The function below keeps track of the position data of the current
and previous
 dots
 */
 void maintainHistory()
 {

   for(int i=0;i<hist-1;i++)
   {
     historyX[i+1]=historyX[i];//Pass the data to the next array
     historyY[i+1]=historyY[i];
   }
    historyX[0]=tempxpos;// receives the X positional data from the mouse
   historyY[0]=tempypos;//receives the Y positional data from the mouse

 }

 /*
 This defines the movment of the dots
 */
 void update()
 {
   maintainHistory();
   if(mousePressed)
   {
     rest_posy = mouseY;
     rest_posx = mouseX;
   }

   force = -k * (tempypos - rest_posy);  // f=-ky
   accel = force / mass;             // Set the acceleration, f=ma == a=f/m
   vely = damp * (vely + accel);     // Set the velocity
   tempypos = tempypos + vely;               // Updated position

   force = -k * (tempxpos - rest_posx);  // f=-ky
   accel = force / mass;             // Set the acceleration, f=ma == a=f/m
   velx = damp * (velx + accel);     // Set the velocity
   tempxpos = tempxpos + velx;               // Updated position

 }

 /*
 This part is allowing to draw the dots like an one line
 */

 void drawdraw()
 {

   float speed=dist(historyX[hist-1],historyY[hist-1],historyX[0],historyY[0]);
   //stroke(50*speed/40+40*mouseY/height,40*speed/20,speed+random(100,255), speed);
   
   //stroke(speed+random(100,255),50*speed/40+40*mouseY/height,40*speed/20,speed);             //red
   if(keyPressed){
     if(key == 'r') //Red Color
       stroke(speed+random(100,255),50*speed/40+40*mouseY/height,50*speed/40+40*mouseY/height,speed);
   }
   else if(keyPressed){
     if(key == 'y') //"Light Mode"
       stroke(50*speed/40+40*mouseY/height, speed+random(100,255), 40*speed/20, speed);  
   }
   else if(keyPressed){ //thin color effect
     if(key == 't')
       stroke(50*speed/40+40*mouseY/height,50*speed/40+40*mouseY/height,speed+random(100,255),speed);
   }
   else{
     stroke(50*speed/40+40*mouseY/height, speed);
   }
   beginShape();
   vertex(historyX[0], historyY[0]);

   for(int i=0;i<historyX.length;i++)
   {
     vertex(historyX[i], historyY[i]);
   }

   vertex(historyX[historyX.length-1],
   historyY[historyY.length-1]);
   endShape();

 }

}

void blur() {
  int index,sum,left,right,top,bottom;
  loadPixels();
  for(int j=0;j<width;j++) {
    for(int i=0;i<height;i++) {
      index=i*width+j;
      //loadPixels();
      // Wraparound offsets
      if(j>0) left=-1; else left=width-1;
      if(j==(width-1)) right=-width+1; else right=1;
      if(i>0) top=-width; else top=(height-1)*width;
      if(i==(height-1)) bottom=-(height-1)*width; else bottom=width;

      // Calculate the sum of n neighbors
      sum=pixels[left+index] & 255; // left middle
      //sum+=pixels[left+top+index] & 255; // left top
      //sum+=pixels[left+bottom+index] & 255; // left bottom
      sum+=pixels[right+index] & 255; // right middle
      //sum+=pixels[right+top+index] & 255; // right top
      //sum+=pixels[right+bottom+index] & 255; // right bottom
      sum+=(pixels[index] & 255); // middle middle
      sum+=pixels[index+top] & 255; // middle top
      sum+=pixels[index+bottom] & 255; // middle bottom
      sum=(sum/5);
      pixels[index]=(sum<<16)+(sum<<8)+sum;
    }
  }
  //updatePixels(0, 0, width, height);
}


